<?php
class WCP_Tree {
    public function __construct() {
        parent::__construct();
    }

    public function get_full_tree_data($post_type) {
        $string = self::get_folder_category_data($post_type, 0, 0);
        return $string['string'];
    }

    public function get_folder_category_data($post_type, $parent = 0, $parentStatus = 0) {
//        echo "<pre>"; print_r($post_type); die;
        $terms = get_terms( $post_type, array(
            'hide_empty' => false,
            'parent'   => $parent,
            'orderby' => 'meta_value_num',
            'order' => 'ASC',
            'hierarchical' => false,
            'update_count_callback' => '_update_generic_term_count',
            'meta_query' => [[
                'key' => 'wcp_custom_order',
                'type' => 'NUMERIC',
            ]]
        ));
        $string = "";
        $child = 0;
        if(!empty($terms)) {
            $child = count($terms);
            foreach($terms as $term) {
                $status = get_term_meta($term->term_id, "is_active", true);
                $return = self::get_folder_category_data($post_type, $term->term_id, $status);
                $class = ($status == 1 && $return['child']>0)?"active":"";
                $class .= ($return['child'])>0?" has-sub-tree":"";
                if($post_type == "attachment") {
                    $class .= (isset($_GET['term']) && $_GET['term'] == $term->slug)?" active-item active-term":"";
                } else {
                    $class .= (isset($_GET[$post_type]) && $_GET[$post_type] == $term->slug)?" active-item active-term":"";
                }
                $status = get_term_meta($term->term_id, "is_highlighted", true);
                $class .= ($status == 1)?" is-high":"";
                $count = ($term->count != 0)?"<span class='total-count'>{$term->count}</span>":"";
                $string .= "<li data-slug='{$term->slug}' class='ui-state-default route {$class}' id='wcp_folder_{$term->term_id}' data-folder-id='{$term->term_id}'><h3 class='title' title='{$term->name}' id='title_{$term->term_id}'><span class='title-text'>{$term->name}</span> <span class='update-inline-record'></span> {$count} <span class='star-icon'></span></h3><span class='nav-icon'><i class='wcp-icon folder-icon-arrow_right'></i></span><span class='ui-icon'><i class='wcp-icon folder-icon-folder'></i></span>	<ul class='space' id='space_{$term->term_id}'>";
                $string .= $return['string'];
                $string .= "</ul></li>";
            }
        }
        return array(
            'string' =>$string,
            'child' => $child
        );
    }

    public function get_option_data_for_select($post_type) {
        $string = "<option value='0'>Parent Folder</option>";
        $string .=  self::get_folder_option_data($post_type, 0, '&nbsp;&nbsp;');
        return $string;
    }

    public function get_folder_option_data($post_type, $parent = 0, $space) {
        $terms = get_terms( $post_type, array(
            'hide_empty' => false,
            'parent'   => $parent,
            'orderby' => 'meta_value_num',
            'order' => 'ASC',
            'hierarchical' => false,
            'meta_query' => [[
                'key' => 'wcp_custom_order',
                'type' => 'NUMERIC',
            ]]
        ) );

        $string = "";
        if(!empty($terms)) {
            foreach($terms as $term) {
                $string .= "<option value='{$term->term_id}'>{$space}{$term->name}</option>";
                $string .= self::get_folder_option_data($post_type, $term->term_id, $space."&nbsp&nbsp");
            }
        }
        return $string;
    }
}